﻿using Xamarin.Forms;
using Syncfusion.SfCalendar.XForms;
using System;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.ComponentModel;

namespace CalendarSample
{
	public partial class CalendarSamplePage : ContentPage
	{
		SfCalendar cal = new SfCalendar();
		DateTime day;
        List<CustomInlineEvent> TempCollection = new List<CustomInlineEvent>();
		List<CustomInlineEvent> Customcollection = new List<CustomInlineEvent>();
        CalendarEventCollection Collection = new CalendarEventCollection();
		public CalendarSamplePage()
		{
			InitializeComponent();
			MonthViewSettings mon = new MonthViewSettings();
			mon.HeaderBackgroundColor = Color.Orange;
			cal.MonthViewSettings = mon;
			cal.OnInlineLoaded += HandleDrawInlineEventHandler;
			cal.SelectionChanged += HandleSelectionEventHandler;
			cal.ShowInlineEvents = true;
			CustomInlineEvent events = new CustomInlineEvent();
			events.StartTime = new DateTime(2017, 6, 11, 9, 0, 0);
			events.EndTime = new DateTime(2017, 6, 11, 12, 0, 0);
			events.Subject = "Go to Meeting";
			events.Location = "Park";
			CustomInlineEvent events12 = new CustomInlineEvent();
			events12.StartTime = new DateTime(2017, 6, 1, 1, 0, 0);
			events12.EndTime = new DateTime(2017, 6, 1, 3, 0, 0);
			events12.Subject = "TestingEvent";
			events12.Location = "ConferenceHall";
			CustomInlineEvent events1 = new CustomInlineEvent();
			events1.StartTime = new DateTime(2017, 6, 11, 11, 0, 0);
			events1.EndTime = new DateTime(2017, 6, 11, 13, 0, 0);
			events1.Subject = "Meeting"; events1.Location = "ConferenceHall";
			CustomInlineEvent events2 = new CustomInlineEvent();
			events2.StartTime = new DateTime(2017, 6, 9, 15, 0, 0);
			events2.EndTime = new DateTime(2017, 6, 9, 18, 0, 0);
			events2.Subject = "Meeting2";
			events2.Location = "Metting Room";
			CustomInlineEvent events3 = new CustomInlineEvent();
			events3.StartTime = new DateTime(2017, 6, 22, 1, 0, 0);
			events3.EndTime = new DateTime(2017, 6, 22, 10, 0, 0);
			events3.Subject = "Meeting3";
			events3.Location = "Hall";
			CustomInlineEvent events4 = new CustomInlineEvent();
			events4.StartTime = new DateTime(2017, 6, 25, 8, 0, 0);
			events4.EndTime = new DateTime(2017, 6, 25, 12, 0, 0);
			events4.Subject = "Meeting4";
			events4.Location = "ConferenceHall";
			Collection.Add(events);
			Collection.Add(events12);
			Collection.Add(events);
			Collection.Add(events12);
			Collection.Add(events2);
			Collection.Add(events3);
			Collection.Add(events4);
			cal.DataSource = Collection;

			Customcollection.Add(events);
			Customcollection.Add(events12);
			Customcollection.Add(events);
			Customcollection.Add(events12);
			Customcollection.Add(events2);
			Customcollection.Add(events3);
			Customcollection.Add(events4);

			Content = cal;
		}




		List<CustomInlineEvent> GetSelectedDateAppointments(DateTime date)
		{
			List<CustomInlineEvent> selectedDateAppointments = new List<CustomInlineEvent>();
			for (int i = 0; i < Customcollection.Count; i++)
			{
				DateTime startDate = Customcollection[i].StartTime;

				if (date.Day == startDate.Day && date.Month == startDate.Month && date.Year == startDate.Year)
				{
					selectedDateAppointments.Add(Customcollection[i]);
				}
			}
			return selectedDateAppointments;
		}

		void HandleSelectionEventHandler(object sender, SelectionChangedEventArgs args)
		{
			day = args.Calendar.SelectedDate;
			TempCollection = GetSelectedDateAppointments(cal.SelectedDate);
		}

		void HandleDrawInlineEventHandler(object sender, InlineEventArgs args)
		{
			ViewModel vm = new ViewModel();
			vm.Today = day.ToString("yy-MMM-dd ddd");
			for (int i = 0; i < TempCollection.Count; i++)
			{
				vm.Collection.Add(new Model() { Subject = TempCollection[i].Subject, Start = TempCollection[i].StartTime.ToString("t"), End = TempCollection[i].EndTime.ToString("t"), Location = TempCollection[i].Location });
			}
			CustomInlineView inlineView = new CustomInlineView(this) { BindingContext = vm };
			StackLayout stk = new StackLayout();
			stk.HeightRequest = 150;
			stk.Children.Add(inlineView);
			args.View = stk;
		}

	}



	public class ViewModel : INotifyPropertyChanged
	{
		private List<Model> collection = new List<Model>();

		public List<Model> Collection
		{
			get
			{
				return collection;
			}

			set
			{
				collection = value;
				OnPropertyChanged("Collection");
			}
		}
		private string today;
		public string Today
		{
			get { return today; }
			set
			{
				today = value;
				OnPropertyChanged("Today");
			}
		}
		protected virtual void OnPropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
		}

		public event PropertyChangedEventHandler PropertyChanged;
	}



	public class Model
	{
		private string subject;

		public string Subject
		{
			get
			{
				return subject;
			}
			set
			{
				subject = value;
			}
		}
		private string start;
		public string Start
		{
			get
			{
				return start;
			}
			set
			{
				start = value;
			}
		}
		private string end;
		public string End
		{
			get
			{
				return end;
			}
			set
			{
				end = value;
			}

		}
		private string location;
		public string Location
		{
			get
			{
				return location;
			}
			set
			{
				location = value;

			}
		}
	}

	public class CustomInlineEvent : CalendarInlineEvent
	{
		public CustomInlineEvent()
		{
		}
		private string location;
		public string Location
		{
			get
			{
				return location;
			}

			set
			{
				location = value;
			}
		}
	}
}
